Hooks:PostHook(GroupAITweakData, "_init_unit_categories", "F_"..Idstring("cock_init_unit_categories"):key(), function(self, difficulty_index)
	local access_type_walk_only = {
		walk = true
	}
	local access_type_all = {
		acrobatic = true,
		walk = true
	}
	local __new_unit_categories = {}
	
	local murky_scar = nil
    local murky_ump = nil

    --Fix the crash issue on Beneath The Mountain
    local lvl_tweak_data = tweak_data_ref and Global.level_data and Global.level_data.level_id and tweak_data_ref.levels[Global.level_data.level_id]
    local level_package = lvl_tweak_data and lvl_tweak_data.package

    if type(level_package) == "table" then
        for _, package in ipairs(level_package) do
            if not murky_scar and (package == "packages/job_mex" or package == "packages/job_mex2" or package == "packages/job_des") then
                murky_scar = Idstring("units/pd2_dlc_des/characters/ene_murkywater_not_security_2/ene_murkywater_not_security_2")
            end
    
            if not murky_ump and (murky_scar  or package == "packages/dlcs/bph/job_bph") then
                murky_ump = Idstring("units/pd2_dlc_des/characters/ene_murkywater_no_light_not_security/ene_murkywater_no_light_not_security")
            end
        end
    else
        if level_package and (level_package == "packages/job_mex" or level_package == "packages/job_mex2" or level_package == "packages/job_des") then
            murky_scar = Idstring("units/pd2_dlc_des/characters/ene_murkywater_not_security_2/ene_murkywater_not_security_2")
        end

        if murky_scar or (level_package and level_package == "packages/dlcs/bph/job_bph") then
            murky_ump = Idstring("units/pd2_dlc_des/characters/ene_murkywater_no_light_not_security/ene_murkywater_no_light_not_security")
        end
    end

    if not murky_ump then
        murky_ump = Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light/ene_murkywater_light")
    end
    if not murky_scar then
        murky_scar = murky_ump
    end


	-- Add UMP Gensec
	if difficulty_index == 6 or difficulty_index == 7 then
	
		__new_unit_categories.FBI_swat_UMP = {
			unit_types = {
				america = {
					Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
				},
				russia = {
					Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_akmsu_smg/ene_akan_cs_cop_akmsu_smg"),
                    Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_asval_smg/ene_akan_cs_cop_asval_smg")
				},
				zombie = {
					Idstring("units/pd2_dlc_hvh/characters/ene_fbi_hvh_2/ene_fbi_hvh_2")
				},
				murkywater = {
                    murky_ump,
                    murky_scar
				},
				federales = {
					Idstring("units/pd2_dlc_bex/characters/ene_swat_policia_federale/ene_swat_policia_federale")
				}
			},
			access = access_type_all
		}
			
	end
	-- Add SkullDozer for Mayhem
	if difficulty_index == 6 then
		__new_unit_categories.FBI_tank = {
			special_type = "tank",
			unit_types = {
				america = {
					Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
					Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
					Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3")
				},
				russia = {
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_r870/ene_akan_fbi_tank_r870"),
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_saiga/ene_akan_fbi_tank_saiga"),
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_rpk_lmg/ene_akan_fbi_tank_rpk_lmg")
				},
				zombie = {
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_1/ene_bulldozer_hvh_1"),
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_2/ene_bulldozer_hvh_2"),
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_3/ene_bulldozer_hvh_3")
				},
				murkywater = {
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_2/ene_murkywater_bulldozer_2"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_3/ene_murkywater_bulldozer_3"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_4/ene_murkywater_bulldozer_4")
				},
				federales = {
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_r870/ene_swat_dozer_policia_federale_r870"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_saiga/ene_swat_dozer_policia_federale_saiga"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_m249/ene_swat_dozer_policia_federale_m249")
				}
			},
			access = access_type_walk_only
		}
	-- Add MedicDozer for DeathWish
	elseif difficulty_index == 7 then
		__new_unit_categories.FBI_tank = {
			special_type = "tank",
			unit_types = {
				america = {
					Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
					Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
					Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic/ene_bulldozer_medic"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_minigun_classic/ene_bulldozer_minigun_classic")
				},
				russia = {
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_r870/ene_akan_fbi_tank_r870"),
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_saiga/ene_akan_fbi_tank_saiga"),
					Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_rpk_lmg/ene_akan_fbi_tank_rpk_lmg"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic/ene_bulldozer_medic"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_minigun_classic/ene_bulldozer_minigun_classic")
				},
				zombie = {
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_1/ene_bulldozer_hvh_1"),
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_2/ene_bulldozer_hvh_2"),
					Idstring("units/pd2_dlc_hvh/characters/ene_bulldozer_hvh_3/ene_bulldozer_hvh_3"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic/ene_bulldozer_medic"),
					Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_minigun_classic/ene_bulldozer_minigun_classic")
				},
				murkywater = {
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_1/ene_murkywater_bulldozer_1"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_2/ene_murkywater_bulldozer_2"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_3/ene_murkywater_bulldozer_3"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_4/ene_murkywater_bulldozer_4"),
					Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_medic/ene_murkywater_bulldozer_medic")
				},
				federales = {
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_r870/ene_swat_dozer_policia_federale_r870"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_saiga/ene_swat_dozer_policia_federale_saiga"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_m249/ene_swat_dozer_policia_federale_m249"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_policia_federale_minigun/ene_swat_dozer_policia_federale_minigun"),
					Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_medic_policia_federale/ene_swat_dozer_medic_policia_federale")
				}
			},
			access = access_type_walk_only
		}
		end
		local __possible_unit_types = table.map_keys(self.unit_categories.spooc.unit_types)
	for i_1, d_1 in pairs(__possible_unit_types) do
		for i_2, d_2 in pairs(__new_unit_categories) do
			if not __new_unit_categories[i_2].unit_types[d_1] then
				local __fix = false
				if not __fix and __new_unit_categories[i_2].unit_types.america then
					__fix = true
					__new_unit_categories[i_2].unit_types[d_1] = __new_unit_categories[i_2].unit_types.america
				end
				if not __fix and self.unit_categories[i_2].unit_types[d_1] then
					__fix = true
					__new_unit_categories[i_2].unit_types[d_1] = self.unit_categories[i_2].unit_types[d_1]
				end
				if not __fix then
					__new_unit_categories[i_2].unit_types[d_1] = {
						Idstring("units/payday2/characters/ene_cop_1/ene_cop_1")
					}
				end
			end
		end
	end
	for i_1, d_1 in pairs(__new_unit_categories) do
		self.unit_categories[i_1] = d_1
	end
end)

Hooks:PostHook(GroupAITweakData, "_init_enemy_spawn_groups", "F_"..Idstring("cock_init_enemy_spawn_groups"):key(), function(self, difficulty_index)
	
	-- SkullDozer spawn group
	if difficulty_index == 6 then
		self.enemy_spawn_groups.tac_bull_rush = {
			amount = {
				4,
				5
			},
			spawn = {
				{ 
					amount_min = 2,
					freq = 2,
					amount_max = 2,
					rank = 2,
					unit = "FBI_tank",
					tactics = self._tactics.tank_rush
				},
				--GenSec Spawn
				{
					amount_min = 3,
					freq = 3,
					amount_max = 3,
					rank = 1,
					unit = "FBI_swat_UMP",
					tactics = self._tactics.swat_rifle
				}
				-- { 
					-- amount_min = 1,
					-- freq = 2,
					-- amount_max = 1,
					-- rank = 3,
					-- unit = "FBI_heavy_G36",
					-- tactics = self._tactics.swat_rifle
				-- },
				-- {
					 -- amount_min = 3,
					 -- freq = 3,
					 -- amount_max = 3,
					 -- rank = 2,
					 -- unit = "FBI_swat_M4",
					 -- tactics = self._tactics.swat_rifle
				-- }
			}
		}
	
	-- MedicDozer Spawn Group
	elseif difficulty_index == 7 then
		self.enemy_spawn_groups.tac_bull_rush = {
			amount = {
				4,
				5
			},
			spawn = {
				{
					amount_min = 2,
					freq = 2,
					amount_max = 2,
					rank = 2,
					unit = "FBI_tank",
					tactics = self._tactics.tank_rush
				},
				--GenSec Spawn
				{
					amount_min = 2,
					freq = 3,
					amount_max = 3,
					rank = 1,
					unit = "FBI_swat_UMP",
					tactics = self._tactics.swat_rifle
				}
				-- {
					-- amount_min = 2,
					-- freq = 2,
					-- amount_max = 2,
					-- rank = 3,
					-- unit = "FBI_heavy_G36",
					-- tactics = self._tactics.swat_rifle
				-- },
				-- {
					 -- amount_min = 3,
					 -- freq = 3,
					 -- amount_max = 3,
					 -- rank = 1,
					 -- unit = "FBI_swat_M4",
					 -- tactics = self._tactics.swat_rifle
				-- }

			}
		}

	end
	
end)

Hooks:PostHook(GroupAITweakData, "_init_task_data", "F_"..Idstring("cock_init_task_data"):key(), function(self, difficulty_index, difficulty)
	
		if difficulty_index == 6 then
		tac_bull_rush = {
				0.05,
				0.05,
				0.05
			}
	
	elseif difficulty_index == 7 then
		tac_bull_rush = {
				0.05,
				0.05,
				0.05
			}
	end
	self.street = deep_clone(self.besiege)
	self.safehouse = deep_clone(self.besiege)
end)